%This M-Function was created automatically by PSG Toolbox.
%See section "Special Subroutines in Toolbox -> User Subroutine in Toolbox" in PSG Help Manual.
%
%Input variables:
%
%Inputs                  PSG Type    PSG Object         Location in Problem Statement                      Class
%matrix_0_data           data        matrix_0           pm_pen(parameter_alpha,L(matrix_0)-L(matrix_1))    double
%matrix_0_vars           vars        matrix_0           pm_pen(parameter_alpha,L(matrix_0)-L(matrix_1))    cell
%matrix_1_data           data        matrix_1           pm_pen(parameter_alpha,L(matrix_0)-L(matrix_1))    double
%matrix_1_vars           vars        matrix_1           pm_pen(parameter_alpha,L(matrix_0)-L(matrix_1))    cell
%parameter_alpha_data    data        parameter_alpha    pm_pen(parameter_alpha,L(matrix_0)-L(matrix_1))    double
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


function [solution_str,outargstruc_arr] = Optimization_subroutine(matrix_0_data,matrix_0_vars,matrix_1_data,matrix_1_vars,parameter_alpha_data)

%Pack data to PSG structure:
count = 0;
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_0',matrix_0_data,matrix_0_vars,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_1',matrix_1_data,matrix_1_vars,[],[]);
%Define problem statement:
problem_statement = sprintf('%s\n',...
'minimize',...
'  pm_pen(parameter_alpha,L(matrix_0)-L(matrix_1))',...
' ');
%Change parameters with their values in problem statement:
problem_statement = strrep(problem_statement,'parameter_alpha',num2str(parameter_alpha_data));

%Optimize problem using mpsg_solver function:
[solution_str, outargstruc_arr] = mpsg_solver(problem_statement, iargstruc_arr);
results = psg_convert_outargstruc(solution_str,outargstruc_arr);
outargstruc_arr = results.data;
solution_str = results.string;

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 

